package minecraft.player;

import minecraft.item.Food;

public class Steve extends Character implements Killable, Talkable {

    private int hunger;
    private int maxHunger;
    private boolean godMode; // nesmrtelnost, zabija na jednu ranu (pokial nie je godMode)

    public Steve(String name, int health, int maxHealth, int attackPower, int defensePower, int hunger, int maxHunger, boolean godMode) {
        super(name, health, maxHealth, attackPower, defensePower);
        this.setHunger(hunger);
        this.setMaxHunger(maxHunger);
        this.setGodMode(godMode);
    }

    public void consume(Food food) {

        if (food.getAmount() > 0) {
            setHealth(Math.min(getHealth() + food.getHeal(), getMaxHealth()));
            setHunger(Math.min(getHunger() + food.getFeed(), getMaxHunger()));

            food.setAmount(food.getAmount() - 1);

            System.out.println(getName() + " sa najedol, hunger je " + getHunger() + " health je " + getHealth());
        }
    }

    @Override
    public void attack() {

    }

    // toto nie je idealna implementacia z hladiska znovupouzitelnosti, ale na ukazku override je to ok
    @Override
    public void attack(NPC who) {
        int realAttackPower = godMode ? who.getMaxHealth() : Math.max(0, getAttackPower() - who.getDefensePower());
        who.setHealth(who.getHealth() - realAttackPower);

        System.out.println(getName() + " zautotocil na " + who.getName() + " damage je " + realAttackPower);
    }
    @Override
    public void attack(Creeper who) {
        int realAttackPower = godMode ? who.getMaxHealth() : Math.max(0, getAttackPower() - who.getDefensePower());

        who.setHealth(who.getHealth() - realAttackPower);
        who.setBombTimer(1.5);

        System.out.println(getName() + " zautotocil na " + who.getName() + " damage je " + realAttackPower);
    }
    @Override
    public void attack(Steve who) {
        if (who.isGodMode())
            return;

        int realAttackPower = godMode ? who.getMaxHealth() : Math.max(0, getAttackPower() - who.getDefensePower());

        who.setHealth(who.getHealth() - realAttackPower);
        System.out.println(getName() + " zautotocil na " + who.getName() + " damage je " + realAttackPower);
    }


    public int getHunger() {
        return hunger;
    }

    public void setHunger(int hunger) {
        this.hunger = hunger;
    }

    public int getMaxHunger() {
        return maxHunger;
    }

    public void setMaxHunger(int maxHunger) {
        this.maxHunger = maxHunger;
    }

    public boolean isGodMode() {
        return godMode;
    }

    public void setGodMode(boolean godMode) {
        this.godMode = godMode;
    }

    @Override
    public void kill() {
        if (!godMode)
            setHealth(0);
    }

    @Override
    public void talk() {
        System.out.println("Ahoj, som " + this.getName());
    }

    @Override
    public void listen() {
        System.out.println("Nepocuvam");
    }
}
